#! /usr/bin/perl

$this_dir = $0;
$this_dir =~ s/\/[^\/]*$// && unshift(@INC,"$this_dir");
$this_dir =~ s/\\[^\\]*$// && unshift(@INC,"$this_dir");

require 'library.cgi';
&parse_form;

if($FORM{'action'} eq "") {
	&admin_header;
	print qq!
	<FORM ACTION="install.cgi" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="step2">
	<H3>Voting Center Installation</H3>
	This program will install and configure Voting Center automatically.  Please follow
	the directions on each step to complete the installation process.<P>
	<H3>Step 1</H3>
	<OL TYPE=1>
	<LI> Using your FTP program or telnet program, create a directory on your web server
	where Voting Center can store its files.  You can name the directory anything you want.</LI><P>
	<LI> Change the permissions on the directory to 777 (Read, Write & Execute to all).
	In most FTP programs, you can change the permissions on the directory by selecting it
	and right clicking on it.  There should be a command named <I>CHMOD</I> or <I>Change
	Permissions</I> in the menu that comes up.  <B><FONT COLOR="BB0000">
	If you are on a windows server, you
	do not need to do this step.</FONT></B></LI><P>
	
	<LI> Enter the absolute path to the directory you just created in the box
	below and then press continue.<BR>
	<INPUT TYPE="TEXT" NAME="base_dir" SIZE=40><P>
	<B>Examples:</B><BR>
	/usr/home/username/www/vcenter<BR>
	c:/web/home/username/vcenter
	</LI><P>
	
	<LI> Enter the absolute path to the directory where you uploaded the cgi scripts.
	<BR>
	<INPUT TYPE="TEXT" NAME="this_dir" VALUE="$this_dir" SIZE=40><P>
	
	</OL>
	<INPUT TYPE="SUBMIT" VALUE="Continue">
	</FORM>
	!;
	
	&admin_footer;
}

elsif($FORM{'action'} eq "step2") {
	
	$FORM{'base_dir'} =~ s/\\/\//g;
	
	if($FORM{'base_dir'} =~ /\/$/) {
		chop($FORM{'base_dir'});
	}
	
	$FORM{'this_dir'} =~ s/\\/\//g;
	
	if($FORM{'this_dir'} =~ /\/$/) {
		chop($FORM{'this_dir'});
	}
	
	if(-e "$FORM{'this_dir'}") {
		if(! -e "$FORM{'this_dir'}/config.cgi") {
			&admin_error("Voting Center was unable to find the path to the directory where you uploaded the cgi scripts.
			Please double check your paths and click <A HREF=\"javascript: history.back()\">here</A> to go back and try again.");
		}
	}
	else {
		&admin_error("Voting Center found the path you entered.  However, Voting Center was unable to find the config.cgi that is suppose to
		be located in the directory.  Please double check that you have uploaded all the .cgi files and make sure that you have specified the
		correct path.");
	}
	
	# If we find the directory lets try creating some files.
	if(-e "$FORM{'base_dir'}") {
		unlink("$FORM{'base_dir'}/test.txt");
		open(TEST,">$FORM{'base_dir'}/test.txt");
		print TEST "Everything is ok!";
		close(TEST);
		
		if(-e "$FORM{'base_dir'}/test.txt") {
			
			$script_directory = $ENV{'HTTP_REFERER'};
			$script_directory =~ s/(.+)\/(.*)$/\1/;
	
			unlink("$FORM{'base_dir'}/test.txt");
			&admin_header;
			print qq!
			<FORM ACTION="install.cgi" METHOD="POST">
			<INPUT TYPE="HIDDEN" NAME="action" VALUE="step3">
			<H3>Step 2</H3>
			<INPUT TYPE="HIDDEN" NAME="base_dir" VALUE="$FORM{'base_dir'}">
			<INPUT TYPE="HIDDEN" NAME="this_dir" VALUE="$FORM{'this_dir'}">
			Please specify the URL to the directory that contains the Voting Center
			CGI scripts.<BR>
			<INPUT TYPE="TEXT" SIZE=40 NAME="script_directory" VALUE="$script_directory"><P>
			
			Using your FTP program, upload the bar graphic (bar.gif) to a directory on your web server
			where it is accessible.  Then enter the URL to the graphic file in the box below.<BR>
			<INPUT TYPE="TEXT" SIZE=40 NAME="image_url" VALUE="http://"><BR>
			If you set this setting incorrectly, all that happens is that the bar graphs
			will not show up properly.<P>
			
			Now please choose a username and password for the administration area.<P>
			
			Username:<BR>
			<INPUT TYPE="TEXT" SIZE=20 NAME="username"><P>
			
			Password:<BR>
			<INPUT TYPE="TEXT" SIZE=20 NAME="password"><P>
			
			<INPUT TYPE="SUBMIT" VALUE="Continue">
			</FORM>
			!;
			&admin_footer;
			# The base directory is set correctly! =)
		}
		else {
			&admin_header;
			print qq!
			<FORM ACTION="install.cgi" METHOD="POST">
			<INPUT TYPE="HIDDEN" NAME="action" VALUE="step2">
			<H3>Error: Access to the directory denied</H3>
			The path you entered was found.  However, Post Office
			was unable to create files in the directory.  Make sure
			that you have set the path to the correct directory and that
			you have changed the permissions to 777 if you are on a Unix server.
			After you have double checked the permissions
			and the path enter your path again in the box below
			and press continue to try again.<P>
			
			<INPUT TYPE="TEXT" NAME="base_dir" VALUE="$FORM{'base_dir'}" SIZE=40><P>
			<INPUT TYPE="HIDDEN" NAME="this_dir" VALUE="$FORM{'this_dir'}">
			<INPUT TYPE="SUBMIT" VALUE="Continue">
			</FORM><P>
			
			If you are still unable to get past this step and you feel that you
			have done everything correctly, use our
			<A HREF="http://www.web-consult.com/scripts/">web forum</A> for technical support.
			<P>
			!;
			&admin_footer;
		}
	}
	
	# Give them an error and tell them to try again.
	else {
		&admin_header;
		print qq!
		<FORM ACTION="install.cgi" METHOD="POST">
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="step2">
		<H3>That path you entered was not found</H3>
		The path you entered to your directory was not found.  Please double check
		that you are entering the correct path.  The path is the actual location of
		the directory on the server, not the web address location.  Please try again
		by entering the path to your directory in the box below.<P>
		
		<INPUT TYPE="TEXT" SIZE=40 NAME="base_dir"><P>
		<B>Hint, The <U>path</U> to this script is:</B> $0<BR>
		Warning: Sometimes this is wrong, it depends on how your server is configured.<P>
		<INPUT TYPE="HIDDEN" NAME="this_dir" VALUE="$FORM{'this_dir'}">
		If you are stuck and cannot figure out the path to the directory you just
		created, you can try asking your server administrator or web hosting
		technical support.<P>
		
		<INPUT TYPE="SUBMIT" VALUE="Continue">
		</FORM><P>
		
		!;
		&admin_footer;
	}
}

elsif($FORM{'action'} eq "step3") {
	
	# We are finished!
	
	$bad = 0;
	
	if($FORM{'this_dir'}) {
		$this_dir = $FORM{'this_dir'};
	}
	
	$this_dir =~ s/\\/\//g;
	
	if($this_dir =~ /\/$/) {
		chop($this_dir);
	}
	
	if(! -e "$this_dir/config.cgi") {
		$bad = 1;
	}
	else {
		if(! open(CONFIG,">$this_dir/config.cgi")) {
			#if(! open(CONFIG,">config.cgi")) {
				$bad = 1;
			#}
		}
	}
	
	if(! $bad) {
		print CONFIG qq!
		\$base_dir = "$FORM{'base_dir'}";
		\$script_directory = "$FORM{'script_directory'}";
		\$image_url = "$FORM{'image_url'}";
		\$this_dir = "$FORM{'this_dir'}";
		\$validate_type = 3;
		\$img_height = 10;
		\$bar_length = 4;
		\$ssi_bar_length = 1;
		\$table_color = "FFFFFF";
		\$row_color = "DDDDDD";
		\$caption_color = "66CCFF";
		\$font_color = "000000";
		\$font_face = "Arial";
		\$font_size = 2;
		\$table_cellspacing = 2;
		\$table_cellpadding = 2;
		\$table_border = 0;
		\$logtime = 7;
		\$version = "3.0";
		\$lockfile_max_try = 10;
		\$table_width = "100\%";
		1;
		!;
		close(CONFIG);
		
		open(PASSWD,">$FORM{'base_dir'}/password.txt") || &admin_error("Unable to create password file");
		$FORM{'password'} = crypt($FORM{'password'},"VC");
		print PASSWD "$FORM{'username'}:$FORM{'password'}\n";
		close(PASSWD);
		
		open(HEADER,">$FORM{'base_dir'}/header.txt") || &admin_error("Unable to create header file");
		print HEADER qq!
<HTML>
<HEAD>
<TITLE>Voting Center $version</TITLE>
</HEAD>
<BODY BGCOLOR="FFFFFF" TEXT="000000" LINK="0000FF" VLINK="0000BB" ALINK="0000BB">
<CENTER>
<TABLE BGCOLOR="#FFFFFF" WIDTH=600 BORDER=0>
<TR><TD>
<CENTER>
<FONT FACE="Arial" SIZE=6><B>Voting Center $version</B></FONT><BR>
</CENTER>
</TD></TR>
<TR><TD>
<FONT FACE="Arial">
<BR>
!;
	close(HEADER);

	open(FOOTER,">$FORM{'base_dir'}/footer.txt") || &admin_error("Unable to create footer file");
	print FOOTER qq!
</FONT>
</TD></TR>
</TABLE></CENTER>
</BODY>
</HTML>
!;
	close(FOOTER);
	}
	else {
		&admin_header;
		print qq!
		<H3>Voting Center Error</H3>
		<FORM ACTION="install.cgi" METHOD="POST">
		<INPUT TYPE="HIDDEN" NAME="action" VALUE="step3">
		<INPUT TYPE="HIDDEN" NAME="base_dir" VALUE="$FORM{'base_dir'}">
		<INPUT TYPE="HIDDEN" NAME="script_directory" VALUE="$FORM{'script_directory'}">
		<INPUT TYPE="HIDDEN" NAME="image_url" VALUE="$FORM{'image_url'}">
		Voting Center was unable to modify the configuration file, config.cgi or was unable to find the config.cgi.
		If you are on an Unix or Linux server, please make sure that you have
		set the permissions on the config.cgi to 777 (Read, Write & Execute to all).<P>

		To make sure that the path to your config.cgi is correct, please enter the path
		to the directory where you have uploaded all the CGI files<BR>
		<INPUT TYPE="TEXT" NAME="this_dir" SIZE=40 VALUE="$this_dir"><P>
		
		<INPUT TYPE="SUBMIT" VALUE="Continue">
		!;
		&admin_footer;
		exit;
	}
	
	&admin_header;
	print qq!
	<H3>Installation Successful</H3>
	Voting Center has been installed successfully on your system.  You may now
	enter the administration area and begin using Voting Center.  The administration
	area is where you will be able to create and manage your Voting Center polling
	topics.  Click <A HREF="admin.cgi">here</A> to enter the administration area.<P>
	!;
	&admin_footer;
}

else {
	&admin_error("Invalid Data: Voting Center does not understand the parameters specified");
}